# This file was generated by Rcpp::compileAttributes
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' Compute a white noise environment with a shift
#' @param t the time point
#' @param env_args other args:
#' t.jump the location for the jump,
#' delta env change that takes place at t.jump
#' sd noise in env
#' sdc noise in cue
#' @details nada
NULL

#' Compute mean fitness under stabilizing selection
#' @param zbar mean trait prior to selection
#' @param theta enironmental optimum
#' @param oz2 strength of stabilizing selection
#' @param gamma 1/(oz2 + Vz2), with Vz2 phenotypic variance
#' @details IN USE
#' @export
Log_W_bar <- function(zbar, theta, oz2, gamma) {
    .Call('phenoecosim_Log_W_bar', PACKAGE = 'phenoecosim', zbar, theta, oz2, gamma)
}

#' Compute mean fitness under stabilizing selection
#' @inheritParams Log_W_bar
#' @param LOG (=TRUE) whether to return the log of fitness
#' @details IN USE
#' @export
W_bar <- function(zbar, theta, oz2, gamma, LOG) {
    .Call('phenoecosim_W_bar', PACKAGE = 'phenoecosim', zbar, theta, oz2, gamma, LOG)
}

#' Compute population growth rate under stabilizing selection and no regulation
#' @param R0 basic reproductive number
#' @param Wbar average fitness
#' @param N number of individuals in this generation
#' @param K carrying capacity
#' @details Assumes ceiling population regulation
#' would be good to have separate DD function specified after
#' chevin and lande 2010
#' @export
R_bar <- function(R0, Wbar, N) {
    .Call('phenoecosim_R_bar', PACKAGE = 'phenoecosim', R0, Wbar, N)
}

#' Compute population growth rate under stabilizing selection and ceiling regulation
#' @param R0 basic reproductive number
#' @param Wbar average fitness
#' @param N number of individuals in this generation
#' @param K carrying capacity
#' @details Assumes ceiling population regulation
#' would be good to have separate DD function specified after
#' chevin and lande 2010
#' @export
R_bar_ceiling <- function(R0, Wbar, N, K) {
    .Call('phenoecosim_R_bar_ceiling', PACKAGE = 'phenoecosim', R0, Wbar, N, K)
}

#' Compute population growth rate under stabilizing selection and theta-logistic regulation
#' @inheritParams R_bar_ceiling
#' @param thetaL theta-logistic parameter for density dependence
#' @details Assumes theta-logistic population regulation
#' would be good to have separate DD function specified after
#' chevin and lande 2010
#' @export
R_bar_thetalog <- function(R0, Wbar, N, K, thetaL) {
    .Call('phenoecosim_R_bar_thetalog', PACKAGE = 'phenoecosim', R0, Wbar, N, K, thetaL)
}

#' Va additive genetic variance in the phenotype as a function of the environment
#' @param env environment in which plastiicty is cued
#' @param GG additive genetic variance-covariance matrix
#' @export
Va <- function(env, GG) {
    .Call('phenoecosim_Va', PACKAGE = 'phenoecosim', env, GG)
}

#' Compute correctly-scaled environment of development and selection
#' @param env_args environment args
#' @param T how many gens
#' @details given a pre-generated vector of random environments
#' @export
make_env <- function(T, env_args) {
    .Call('phenoecosim_make_env', PACKAGE = 'phenoecosim', T, env_args)
}

#' Compute phenotypic dynamic Time Series of trait + demographic change under stabilizing selection as
#' function of environment (after Lande Chevin)
#' @param T end time, assuming start time of 1
#' @param X parameters (z, a, b, wbar, logN, theta)
#' @param params a list with (gamma_sh, omegaz, A, B, R0, var_a, Vb, delta, sigma_xi, rho_tau, fractgen)
#' @param env_args extra args for env.fn
#' @details NB - for now assume Tchange = 0 and demography after CL 2010
#' @value a long matrix
#' @export
simulate_pheno_ts <- function(T, X, params, env_args) {
    .Call('phenoecosim_simulate_pheno_ts', PACKAGE = 'phenoecosim', T, X, params, env_args)
}

